"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _reactDom2 = _interopRequireDefault(_reactDom);

var _find = require("lodash/find");

var _find2 = _interopRequireDefault(_find);

var _orderBy = require("lodash/orderBy");

var _orderBy2 = _interopRequireDefault(_orderBy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_React$Component) {
    _inherits(Table, _React$Component);

    function Table(props) {
        _classCallCheck(this, Table);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Table).call(this, props));

        _this.data = props.data;

        _this.state = {
            page: 0,
            sorting: false,
            lastOrder: 'asc',
            sort: [],
            colWidths: [],
            tableHeight: null,
            tableWidth: null,
            draggingSeparatorIndex: null,
            headerHeight: props.headerHeight || 50,
            rowHeight: props.rowHeight || 50

        };
        return _this;
    }

    _createClass(Table, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            var table = _reactDom2.default.findDOMNode(this.refs.table);
            var tableContainer = _reactDom2.default.findDOMNode(this.refs.tableContainer);
            var tableHeight = table.offsetHeight;
            var tableWidth = tableContainer.offsetWidth;
            var theadWidth = 0;

            var ths = table.querySelectorAll('thead th');
            var colWidths = [];

            _react2.default.Children.forEach(this.props.children, function (column) {
                var colWidth = Math.floor(column.props.width || tableWidth / ths.length);

                colWidths.push(colWidth);
                theadWidth += colWidth;
            });

            this.setState({ colWidths: colWidths, tableHeight: tableHeight, tableWidth: tableWidth, theadWidth: theadWidth });
        }
    }, {
        key: "sortBy",
        value: function sortBy(e, columnIndex) {
            var _this2 = this;

            var _state = this.state;
            var sort = _state.sort;
            var lastOrder = _state.lastOrder;
            var blockOnProcessing = this.props.blockOnProcessing;

            var data = this.data;
            var stackSort = e.ctrlKey;

            if (blockOnProcessing) {
                this.setState({ sorting: true });
            }

            var alreadyHasSort = false;

            var newLastOrder = lastOrder;

            var newSort = [];
            sort.forEach(function (sortItem) {
                if (sortItem.columnIndex === columnIndex) {
                    alreadyHasSort = true;
                    var order = sortItem.order === 'asc' ? 'desc' : 'asc';
                    newLastOrder = order;
                    newSort.push({
                        order: order,
                        columnIndex: columnIndex
                    });
                }

                if (stackSort) {
                    newSort.push(Object.assign({}, sortItem));
                }
            });

            if (!alreadyHasSort) {
                newSort.push({
                    columnIndex: columnIndex,
                    order: lastOrder
                });
            }

            var sortColumnsArr = [];
            var orderArr = [];
            newSort.forEach(function (sortItem) {
                sortColumnsArr.push("" + sortItem.columnIndex);
                orderArr.push(sortItem.order);
            });

            setTimeout(function () {
                _this2.data = (0, _orderBy2.default)(data, sortColumnsArr, orderArr);

                _this2.setState({
                    sort: newSort,
                    lastOrder: newLastOrder,
                    sorting: false
                });
            }, 1);
        }
    }, {
        key: "renderHead",
        value: function renderHead() {
            var _this3 = this;

            var _state2 = this.state;
            var colWidths = _state2.colWidths;
            var sort = _state2.sort;
            var headerHeight = _state2.headerHeight;


            var columns = _react2.default.Children.map(this.props.children, function (column, columnIndex) {

                var sortProp = (0, _find2.default)(sort, { columnIndex: columnIndex });
                var colWidth = colWidths[columnIndex];

                return _react2.default.cloneElement(column, {
                    sortProp: sortProp,
                    columnIndex: columnIndex,
                    onClick: function onClick(e, thIndex) {
                        _this3.sortBy(e, thIndex);
                    },
                    width: colWidth,
                    height: headerHeight
                });
            });

            return _react2.default.createElement(
                "thead",
                { key: "thead" },
                _react2.default.createElement(
                    "tr",
                    { style: { whiteSpace: 'nowrap' } },
                    columns
                )
            );
        }
    }, {
        key: "renderBody",
        value: function renderBody() {
            var _props = this.props;
            var perPage = _props.perPage;
            var height = _props.height;
            var _state3 = this.state;
            var page = _state3.page;
            var colWidths = _state3.colWidths;
            var containerScrollTop = _state3.containerScrollTop;
            var rowHeight = _state3.rowHeight;

            var data = this.data;

            //Params for non-pages table

            var topHiddenHeight = 0;
            var bottomHiddenHeight = 0;

            var count = height / rowHeight;
            var from = (containerScrollTop || 0) / rowHeight;

            var listData = undefined;

            if (perPage) {
                listData = data.slice(page * perPage, page * perPage + perPage);
            } else {

                topHiddenHeight = from * rowHeight;

                bottomHiddenHeight = (data.length - (from + count)) * rowHeight;
                bottomHiddenHeight = bottomHiddenHeight >= 0 ? bottomHiddenHeight : 0;

                listData = data.slice(from, from + count);
            }

            var trs = listData.map(function (row, trIndex) {
                var tds = row.map(function (dataItem, tdIndex) {
                    var style = {};
                    if (colWidths[tdIndex] !== undefined) {
                        //style.width = colWidths[tdIndex];
                    }
                    return _react2.default.createElement(
                        "td",
                        { style: style, key: tdIndex },
                        dataItem
                    );
                });

                var key = trIndex + from;

                return _react2.default.createElement(
                    "tr",
                    { key: key, style: { height: rowHeight, whiteSpace: 'nowrap' } },
                    tds
                );
            });

            var bottomHiddenTr = undefined;
            if (bottomHiddenHeight) {
                bottomHiddenTr = _react2.default.createElement("tr", { style: { height: bottomHiddenHeight } });
            }

            return _react2.default.createElement(
                "tbody",
                { key: "tbody" },
                _react2.default.createElement("tr", { style: { height: topHiddenHeight } }),
                trs,
                bottomHiddenTr
            );
        }
    }, {
        key: "renderControl",
        value: function renderControl() {
            var _this4 = this;

            var _state4 = this.state;
            var colWidths = _state4.colWidths;
            var tableHeight = _state4.tableHeight;
            var tableWidth = _state4.tableWidth;
            var draggingSeparatorIndex = _state4.draggingSeparatorIndex;
            var debug = this.props.debug;


            var style = {
                position: 'relative'
            };

            var leftOffset = 0;

            var separators = colWidths.map(function (colWidth, index) {
                //Don't draw last separator
                if (index === colWidths.length - 1) {
                    return;
                }

                var style = {
                    left: colWidth + leftOffset,
                    paddingLeft: 5,
                    paddingRight: 5,
                    backgroundColor: '#f00',
                    height: tableHeight,
                    position: 'absolute',
                    zIndex: 10,
                    cursor: 'col-resize',
                    opacity: debug ? 0.1 : 0
                };

                if (isNaN(style.left)) {
                    debugger;
                }

                leftOffset = leftOffset + colWidth + 3;

                return _react2.default.createElement("div", { key: "separator_" + index,
                    style: style,
                    onMouseDown: function onMouseDown(e) {
                        _this4.onStartDragSeparator(e, index);
                    } });
            });

            var blockingSelectDivStyle = {
                position: 'absolute',
                width: tableWidth,
                height: tableHeight,
                zIndex: 9,
                backgroundColor: '#0F0',
                opacity: debug ? 0.1 : 0
            };

            var blockingSelectDiv = undefined;
            if (draggingSeparatorIndex !== null) {
                blockingSelectDiv = _react2.default.createElement("div", { style: blockingSelectDivStyle });
            }

            return _react2.default.createElement(
                "div",
                { style: style },
                separators,
                blockingSelectDiv
            );
        }
    }, {
        key: "renderBlockScreen",
        value: function renderBlockScreen() {
            var _state5 = this.state;
            var sorting = _state5.sorting;
            var tableWidth = _state5.tableWidth;
            var tableHeight = _state5.tableHeight;

            var blockScreenDivStyle = {
                position: 'absolute',
                width: tableWidth,
                height: tableHeight,
                backgroundColor: '#000',
                opacity: 0.1
            };

            if (sorting) {
                return _react2.default.createElement("div", { style: blockScreenDivStyle });
            }
        }
    }, {
        key: "renderPagination",
        value: function renderPagination() {
            var _this5 = this;

            var data = this.data;
            var page = this.state.page;
            var perPage = this.props.perPage;


            if (!perPage) {
                return;
            }

            var totalPages = data.length / perPage;

            return _react2.default.createElement(
                "div",
                null,
                _react2.default.createElement(
                    "button",
                    { onClick: function onClick() {
                            _this5.setState({ page: page - 1 });
                        }, disabled: page === 0 },
                    "prev"
                ),
                _react2.default.createElement(
                    "span",
                    null,
                    page + 1,
                    " of ",
                    totalPages
                ),
                _react2.default.createElement(
                    "button",
                    { onClick: function onClick() {
                            _this5.setState({ page: page + 1 });
                        }, disabled: page === totalPages - 1 },
                    "next"
                )
            );
        }
    }, {
        key: "onStartDragSeparator",
        value: function onStartDragSeparator(e, separatorIndex) {
            this.setState({
                draggingSeparatorX: e.clientX,
                draggingSeparatorIndex: separatorIndex
            });
        }
    }, {
        key: "onStopDragSeparator",
        value: function onStopDragSeparator() {
            this.setState({ draggingSeparatorIndex: null });
        }
    }, {
        key: "onDragSeparator",
        value: function onDragSeparator(e) {
            var _this6 = this;

            var _state6 = this.state;
            var draggingSeparatorIndex = _state6.draggingSeparatorIndex;
            var draggingSeparatorX = _state6.draggingSeparatorX;
            var colWidths = _state6.colWidths;


            if (draggingSeparatorIndex !== null) {
                (function () {
                    var diff = draggingSeparatorX - e.clientX;

                    var hasWrongWidth = false;

                    var newColWidths = colWidths.map(function (colWidth, index) {
                        if (draggingSeparatorIndex === index) {
                            return colWidth - diff;
                        }

                        if (draggingSeparatorIndex + 1 === index) {
                            return colWidth + diff;
                        }

                        return colWidth;
                    });

                    newColWidths.forEach(function (newColWidth) {
                        if (newColWidth < 20) {
                            hasWrongWidth = true;
                        }
                    });

                    if (!hasWrongWidth) {
                        var newTableHeight = _reactDom2.default.findDOMNode(_this6.refs.table).offsetHeight;
                        _this6.setState({
                            colWidths: newColWidths,
                            draggingSeparatorX: e.clientX,
                            tableHeight: newTableHeight
                        });
                    }
                })();
            }
        }
    }, {
        key: "onScrollTableContainer",
        value: function onScrollTableContainer(e) {
            this.setState({ containerScrollTop: e.target.scrollTop });
        }
    }, {
        key: "render",
        value: function render() {
            var _this7 = this;

            var _state7 = this.state;
            var theadWidth = _state7.theadWidth;
            var containerScrollTop = _state7.containerScrollTop;
            var tableWidth = _state7.tableWidth;
            var _props2 = this.props;
            var height = _props2.height;
            var width = _props2.width;


            var tableStyle = {
                tableLayout: 'fixed',
                minWidth: theadWidth,
                maxWidth: theadWidth,
                width: theadWidth
            };

            var tableContainerStyle = {
                position: 'relative',
                height: height,
                overflowY: height ? 'auto' : 'hidden',
                overflowX: width ? 'auto' : 'hidden'
            };

            var fixedTableStyle = {
                minWidth: theadWidth,
                maxWidth: theadWidth,
                width: theadWidth,
                tableLayout: 'fixed',
                position: 'absolute',
                top: containerScrollTop
            };

            return _react2.default.createElement(
                "div",
                { className: "react-solid-table", style: { width: width } },
                _react2.default.createElement(
                    "div",
                    { ref: "tableContainer",
                        className: "tableContainer",
                        style: tableContainerStyle,
                        onMouseMove: function onMouseMove(e) {
                            _this7.onDragSeparator(e);
                        },
                        onMouseUp: function onMouseUp(e) {
                            _this7.onStopDragSeparator(e);
                        },
                        onMouseLeave: function onMouseLeave(e) {
                            _this7.onStopDragSeparator(e);
                        },
                        onScroll: function onScroll(e) {
                            _this7.onScrollTableContainer(e);
                        } },
                    this.renderBlockScreen(),
                    this.renderControl(),
                    _react2.default.createElement(
                        "table",
                        { style: tableStyle, ref: "table" },
                        this.renderHead(),
                        this.renderBody()
                    ),
                    _react2.default.createElement(
                        "table",
                        { style: fixedTableStyle },
                        this.renderHead()
                    )
                ),
                this.renderPagination()
            );
        }
    }]);

    return Table;
}(_react2.default.Component);

Table.propTypes = {
    data: _react2.default.PropTypes.array.isRequired,
    //liveResize: React.PropTypes.bool,
    debug: _react2.default.PropTypes.bool,
    perPage: _react2.default.PropTypes.number,
    blockOnProcessing: _react2.default.PropTypes.bool
};
exports.default = Table;