var path = require('path');
var webpack = require('webpack');

module.exports = {
    entry: [
        './example/src/index.js'
    ],
    module: {
        loaders: [
            {
                test: /\.js?$/,
                exclude: /node_modules/,
                loader: 'babel'
            },
            {
                test: /\.less$/,
                loader: "style!css!less"
            }
        ]
    },
    resolve: {
        extensions: ['', '.js', '.jsx']
    },
    output: {
        path: path.join(__dirname, 'example', 'dist'),
        filename: 'bundle.js'
    },
    devServer: {
        contentBase: './example/dist',
    },
    //target: 'node',
    plugins: [
        new webpack.DefinePlugin({
            'process.env': {
                'NODE_ENV': '"production"'
            }
        })
    ]
};